<?php
// +----------------------------------------------------------------------+
// | popoon                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2006 Bitflux GmbH                                 |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// | http://www.apache.org/licenses/LICENSE-2.0                           |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or      |
// | implied. See the License for the specific language governing         |
// | permissions and limitations under the License.                       |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: text.php 7529 2006-07-13 12:15:16Z chregu $

/**
* Outputs the XML-Document as XML
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: text.php 7529 2006-07-13 12:15:16Z chregu $
* @package  popoon
*/
class popoon_components_serializers_text extends popoon_components_serializer {
    
    public $XmlFormat = "Own";
    protected $contentType = "text";
    
    function __construct (&$sitemap) {
        $this->sitemap = &$sitemap;
    }
    
    function init($attribs) {
        parent::init($attribs);
    }
    
    function DomStart(&$xml) {
        
        if (is_object($xml)) {
            $xml = preg_replace("#^<\?xml[^>]+\?>[\s\n\r]*#","",$xml->saveXML());
           print html_entity_decode($xml,ENT_QUOTES,'UTF-8');
        } else {
            print $xml;
        }
    }
}


?>
